using System;
using System.Drawing;
using System.Windows.Forms;

namespace Cocomo
{
	public partial class frmMain : Form
	{
		private double RELY;
		private double DATA;
		private double CPLX;
		private double TIME;
		private double STOR;
		private double VIRT;
		private double TURN;

		private double ACAP;
		private double AEXP;
		private double PCAP;
		private double VEXP;
		private double LEXP;

		private double MODP;
		private double TOOL;
		private double SCED;
		private string[] _rows;

		public frmMain()
		{
			InitializeComponent();
		}

		private void Init()
		{
			comboBox1.SelectedIndex = 0;
			comboBox2.SelectedIndex = 4;
			comboBox3.SelectedIndex = 1;
			comboBox4.SelectedIndex = 3;
			comboBox5.SelectedIndex = 3;
			comboBox6.SelectedIndex = 2;
			comboBox7.SelectedIndex = 0;
			comboBox8.SelectedIndex = 0;
			comboBox9.SelectedIndex = 0;
			comboBox10.SelectedIndex = 3;
			comboBox11.SelectedIndex = 3;
			comboBox12.SelectedIndex = 3;
			comboBox13.SelectedIndex = 3;
			comboBox14.SelectedIndex = 3;
			comboBox16.SelectedIndex = 3;
			comboBox17.SelectedIndex = 4;
		}
	
		private void Button1Click(object sender, EventArgs e)
		{
			double p1, c2, p2;
			double c1 = p1 = c2 = p2 = 0;

			switch (comboBox1.SelectedIndex)
			{ //        
				case 0:  // 
					c1 = 3.2;
					p1 = 1.05;
					c2 = 2.5;
					p2 = 0.38;
					break;
				case 1:  // 
					c1 = 3;
					p1 = 1.12;
					c2 = 2.5;
					p2 = 0.35;
					break;
				case 2:  // 
					c1 = 2.8;
					p1 = 1.2;
					c2 = 2.5;
					p2 = 0.32;
					break;
			}

			double size = double.Parse(textBox1.Text) / 1000;

			double eaf = RELY * DATA * CPLX * TIME * STOR * VIRT * TURN * ACAP * AEXP * PCAP * VEXP * LEXP * MODP * TOOL * SCED;

			label23.Text = "EAF = " + eaf.ToString("F3");
			double work = c1 * eaf * Math.Pow(size, p1);
			double time = c2 * Math.Pow(work, p2);

			label24.Text = string.Format(" = {0} * EAF * ({1} ^ {2}) = {3} -.", c1.ToString("F2"), size.ToString("F2"),
				p1.ToString("F2"), work.ToString("F2"));
			label25.Text = string.Format(" = {0} * ({1} ^ {2}) = {3} .", c2.ToString("F2"), work.ToString("F2"),
				p2.ToString("F2"), time.ToString("F2"));
			
			//   
			double lcPlanningWork = (work * 0.08);
			double lcPlanningTime = (time * 0.36);
			double lcPlanningWorkers = (lcPlanningWork / lcPlanningTime);
			// 
			double lcProjectingWork = (work * 0.18);
			double lcProjectingTime = (time * 0.36);
			double lcProjectingWorkers = (lcProjectingWork / lcProjectingTime); //  
			// 
			double lcDetailProjectingWork = (work * 0.25);
			double lcDetailProjectingTime = (time * 0.18);
			double lcDetailProjectingWorkers = (lcDetailProjectingWork / lcDetailProjectingTime);
			//   
			double lcCodingWork = (work * 0.26);
			double lcCodingTime = (time * 0.18);
			double lcCodingWorkers = (lcCodingWork / lcCodingTime);
			//  
			double lcTestingWork = (work * 0.31); 
			double lcTestingTime = (time * 0.28); 
			double lcTestingWorkers = (lcTestingWork / lcTestingTime);

			double workPlus = work * (1 + 0.08); //
			double timePlus = time * (1 + 0.36); //
			double workersAverage = (workPlus / timePlus); // - 
			double workersMax = Math.Max(lcPlanningWorkers, lcProjectingWorkers); 
			workersMax = Math.Max(workersMax, lcDetailProjectingWorkers);
			workersMax = Math.Max(workersMax, lcCodingWorkers);
			workersMax = Math.Max(workersMax, lcTestingWorkers);  //  

			//      WBS
			double analysisSpecifications = (workPlus * 0.04); // 
			double projecting = (workPlus * 0.12);			 // 
			double programming = (workPlus * 0.44);			//
			double planTesting = (workPlus * 0.06);			// 
			double verification = (workPlus * 0.14);		   //  
			double documentation = (workPlus * 0.07);		  // 
			double configuration = (workPlus * 0.07);		  //    
			double guides = (workPlus * 0.06);				 // 
		   

			dataGridView1[1, Index("")].Value = workPlus.ToString("F2");
			dataGridView1[2, Index("")].Value = timePlus.ToString("F2");
			dataGridView1[3, Index("  ")].Value = Math.Round(workersMax + 0.5);
			dataGridView1[3, Index("  ")].Value = Math.Round(workersAverage + 0.5);

			dataGridView1[1, Index(" ")].Value = analysisSpecifications.ToString("F2");
			dataGridView1[1, 13/*Index("")*/].Value = projecting.ToString("F2");			
			dataGridView1[1, Index("")].Value = programming.ToString("F2");
			dataGridView1[1, Index(" ")].Value = planTesting.ToString("F2");
			dataGridView1[1, Index("  ")].Value = verification.ToString("F2");
			dataGridView1[1, Index("  ")].Value = documentation.ToString("F2");
			dataGridView1[1, Index("    ")].Value = configuration.ToString("F2");
			dataGridView1[1, Index(" ")].Value = guides.ToString("F2");

			Write(Index("   "), lcPlanningWork, lcPlanningTime, lcPlanningWorkers);
			Write(7/*""*/, lcProjectingWork, lcProjectingTime, lcProjectingWorkers);
			Write(Index(" "), lcDetailProjectingWork, lcDetailProjectingTime, lcDetailProjectingWorkers);
			Write(Index("   "), lcCodingWork, lcCodingTime, lcCodingWorkers);
			Write(Index(" "), lcTestingWork, lcTestingTime, lcTestingWorkers);
		}

		private int Index(string s)
		{
			return Array.FindIndex(_rows, r => r.Equals(s));
		}

		private void Write(int i, double d1, double d2, double d3)
		{
			dataGridView1[1, i].Value = d1.ToString("F2");
			dataGridView1[2, i].Value = d2.ToString("F2");
			dataGridView1[3, i].Value = d3.ToString("F2");
		}

		#region  

		private void ComboBox2SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox2.SelectedIndex)
			{
				case 0:
					RELY = 1;
					break;
				case 1:
					RELY = 0.75;
					break;
				case 2:
					RELY = 0.86;
					break;
				case 3:
					RELY = 1.15;
					break;
				case 4:
					RELY = 1.4;
					break;
			}
		}

		private void ComboBox3SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox3.SelectedIndex)
			{
				case 0:
					DATA = 1;
					break;
				case 1:
					DATA = 0.94;
					break;
				case 2:
					DATA = 1.08;
					break;
				case 3:
					DATA = 1.16;
					break;
			}
		}

		private void ComboBox4SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox4.SelectedIndex)
			{
				case 0:
					CPLX = 1;
					break;
				case 1:
					CPLX = 0.7;
					break;
				case 2:
					CPLX = 0.85;
					break;
				case 3:
					CPLX = 1.15;
					break;
				case 4:
					CPLX = 1.3;
					break;
			}
		}

		private void ComboBox6SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox6.SelectedIndex)
			{
				case 0:
					TIME = 1;
					break;
				case 1:
					TIME = 1.11;
					break;
				case 2:
					TIME = 1.5;
					break;
			}
		}

		private void ComboBox7SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox7.SelectedIndex)
			{
				case 0:
					STOR = 1;
					break;
				case 1:
					STOR = 1.06;
					break;
				case 2:
					STOR = 1.21;
					break;
			}
		}

		private void ComboBox8SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox8.SelectedIndex)
			{
				case 0:
					VIRT = 1;
					break;
				case 1:
					VIRT = 0.87;
					break;
				case 2:
					VIRT = 1.15;
					break;
				case 3:
					VIRT = 1.3;
					break;
			}
		}

		private void ComboBox9SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox9.SelectedIndex)
			{
				case 0:
					TURN = 1;
					break;
				case 1:
					TURN = 0.87;
					break;
				case 2:
					TURN = 1.07;
					break;
				case 3:
					TURN = 1.15;
					break;
			}
		}

		private void ComboBox11SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox11.SelectedIndex)
			{
				case 0:
					ACAP = 1;
					break;
				case 1:
					ACAP = 1.46;
					break;
				case 2:
					ACAP = 1.19;
					break;
				case 3:
					ACAP = 0.86;
					break;
				case 4:
					ACAP = 0.71;
					break;
			}
		}

		private void ComboBox5SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox5.SelectedIndex)
			{
				case 0:
					AEXP = 1;
					break;
				case 1:
					AEXP = 1.29;
					break;
				case 2:
					AEXP = 1.15;
					break;
				case 3:
					AEXP = 0.91;
					break;
				case 4:
					AEXP = 0.82;
					break;
			}
		}

		private void ComboBox12SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox12.SelectedIndex)
			{
				case 0:
					PCAP = 1;
					break;
				case 1:
					PCAP = 1.42;
					break;
				case 2:
					PCAP = 1.17;
					break;
				case 3:
					PCAP = 0.86;
					break;
				case 4:
					PCAP = 0.7;
					break;
			}
		}

		private void ComboBox13SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox13.SelectedIndex)
			{
				case 0:
					VEXP = 1;
					break;
				case 1:
					VEXP = 1.21;
					break;
				case 2:
					VEXP = 1.1;
					break;
				case 3:
					VEXP = 0.9;
					break;
			}
		}

		private void ComboBox14SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox14.SelectedIndex)
			{
				case 0:
					LEXP = 1;
					break;
				case 1:
					LEXP = 1.14;
					break;
				case 2:
					LEXP = 1.07;
					break;
				case 3:
					LEXP = 0.95;
					break;
			}
		}

		private void ComboBox10SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox10.SelectedIndex)
			{
				case 0:
					MODP = 1;
					break;
				case 1:
					MODP = 1.24;
					break;
				case 2:
					MODP = 1.1;
					break;
				case 3:
					MODP = 0.91;
					break;
				case 4:
					MODP = 0.82;
					break;
			}
		}

		private void ComboBox16SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox16.SelectedIndex)
			{
				case 0:
					TOOL = 1;
					break;
				case 1:
					TOOL = 1.24;
					break;
				case 2:
					TOOL = 1.1;
					break;
				case 3:
					TOOL = 0.91;
					break;
				case 4:
					TOOL = 0.82;
					break;
			}
		}

		private void ComboBox17SelectedIndexChanged(object sender, EventArgs e)
		{
			switch (comboBox17.SelectedIndex)
			{
				case 0:
					SCED = 1;
					break;
				case 1:
					SCED = 1.23;
					break;
				case 2:
					SCED = 1.08;
					break;
				case 3:
					SCED = 1.04;
					break;
				case 4:
					SCED = 1.1;
					break;
			}
		}

		#endregion

		private void Form1Load(object sender, EventArgs e)
		{
			Init();
			try
			{
				_rows = new[]
								{
									" ",									 
									"",
									"",
									"  ",
									"  ",

									"    ",
									"   ",
									"",
									" ",
									"   ",
									" ",

									"   ",
									" ",
									" ",
									"",
									" ",
									"  ",
									"  ",
									"    ",
									" "
								};
				Font boldFont = new Font(Font, FontStyle.Bold);
				foreach (string row in _rows)
				{
					int index = dataGridView1.Rows.Add(row);
					var dataGridRow = dataGridView1.Rows[index];
					if (index == 0 || index == 5 || index == 11)
					{
						dataGridRow.DefaultCellStyle.Font = boldFont;
					}
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}
	}
}